- name: Resolves current version
  set_fact:
    current_nx_version: "{{ (nx_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[1]
                                if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                    and nx_dc.resources[0].spec.template is defined
                                    and nx_dc.resources[0].spec.template.spec is defined
                                    and nx_dc.resources[0].spec.template.spec.containers is defined
                                    and nx_dc.resources[0].spec.template.spec.containers[0] is defined
                                    and nx_dc.resources[0].spec.template.spec.containers[0].image is defined
                                    and (nx_dc.resources[0].spec.template.spec.containers[0].image.split(':')) | length == 2)
                                else ((nx_dc.resources[0].spec.template.spec.containers[0].image.split(':'))[2]
                                    if ((deployment_kind == 'Deployment' or (do_triggers | default(False)) == False)
                                        and nx_dc.resources[0].spec.template is defined
                                        and nx_dc.resources[0].spec.template.spec is defined
                                        and nx_dc.resources[0].spec.template.spec.containers is defined
                                        and nx_dc.resources[0].spec.template.spec.containers[0] is defined
                                        and nx_dc.resources[0].spec.template.spec.containers[0].image is defined)
                                    else (nx_dc.resources[0].spec.triggers[0].imageChangeParams.from.name.split(':'))[1]) }}"
- block:
  - name: Fails if current version unknown
    fail:
      msg: "Nexus tag unknown {{ current_nx_version }}"
    when:
    - current_nx_version not in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01', '3.38.1-01', '3.39.0-01', '3.39.0-01-1', '3.40.0-03', '3.40.1-01', '3.41.0-01', '3.41.1-01' ]
  - name: Checks upgrade supported
    fail:
      msg: "Can not upgrade from {{ current_nx_version }} to {{ nexus_tag }}"
    when:
    - >
        (current_nx_version == '3.41.1-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01', '3.38.1-01', '3.39.0-01', '3.39.0-01-1', '3.40.0-03', '3.40.1-01', '3.41.0-01' ])
        or (current_nx_version == '3.41.0-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01', '3.38.1-01', '3.39.0-01', '3.39.0-01-1', '3.40.0-03', '3.40.1-01' ])
        or (current_nx_version == '3.40.1-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01', '3.38.1-01', '3.39.0-01', '3.39.0-01-1', '3.40.0-03' ])
        or (current_nx_version == '3.40.0-03' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01', '3.38.1-01', '3.39.0-01', '3.39.0-01-1' ])
        or (current_nx_version == '3.39.0-01-1' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01', '3.38.1-01', '3.39.0-01' ])
        or (current_nx_version == '3.39.0-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01', '3.38.1-01' ])
        or (current_nx_version == '3.38.1-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1', '3.38.0-01' ])
        or (current_nx_version == '3.38.0-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02', '3.37.3-02-1' ])
        or (current_nx_version == '3.37.3-02-1' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01', '3.37.3-02' ])
        or (current_nx_version == '3.37.3-02' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01', '3.37.1-01' ])
        or (current_nx_version == '3.37.1-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01', '3.37.0-01' ])
        or (current_nx_version == '3.37.0-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02', '3.36.0-01' ])
        or (current_nx_version == '3.36.0-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01', '3.35.0-02' ])
        or (current_nx_version == '3.35.0-02' and nexus_tag in [ '3.32.0-03', '3.34.0-01', '3.34.1-01' ])
        or (current_nx_version == '3.34.1-01' and nexus_tag in [ '3.32.0-03', '3.34.0-01' ])
        or (current_nx_version == '3.34.0-01' and nexus_tag in [ '3.32.0-03' ])
  - include_role:
      name: nexus
      tasks_from: upgrade-step.yaml
    vars:
      target: "{{ nexus_tag }}"
    when:
    - nexus_tag != current_nx_version
    - nexus_snapshot_data_on_upgrade | default(True)
    - do_backups
  when:
  - current_nx_version != 'master'
  - current_nx_version != 'devel'
  - current_nx_version != 'stage'
- name: Issue a warning when migrating from master to release
  debug:
    msg: |
      WARNING - about to deploy {{ nexus_tag }} over CI version {{ current_nx_version }}
  when:
  - current_nx_version in [ 'master', 'devel', 'stage' ]
